#Define TEST__SQL .F.

#If TEST__SQL

    Private goSql


    * voir DoSQLscript_assign
    #Define SQL__ Text To goSql.DoSQLscript  Textmerge Noshow
    #Define __SQL Endtext

    *  utiliser pour initialiser la chaine de connection  attribut p_cConnectStr
    #Define INIT_CHAINE_DE_CONNECTION goSql.Setup()
    * exemble : CHANGEdb = "t6"
    #Define CHANGEdb goSql.p_cDatabase
    #Define PERMANENT_CONNECTION goSql.p_lPermnntConnection = .T.
    #Define CLOSE_CONNECTION goSql.UnConnetion()


    m.goSql = Createobject("SQLClass")

    PERMANENT_CONNECTION

    With m.goSql

        .p_lLocal = .T.
        .p_cServeurLocal="localhost"
        .p_cServeurDistant = ""
        .p_cPassword="XXXX"
        .p_cDatabase="Essais"

        .Setup()    && Initialisation de l'objet

    Endwith
    INIT_CHAINE_DE_CONNECTION

    lcDBname = "t6"

    * cration d'une database
    SQL__

    Create Database <<lcDBname >>;

    __SQL

    Set Step On

    CHANGEdb = lcDBname

    &&  excuter si vous modifier la chaine de connection
    INIT_CHAINE_DE_CONNECTION


    SQL__

    Create Table weather (
    city            Varchar(80),
    temp_lo         Int,           -- low temperature
    temp_hi         Int,           -- High temperature
    prcp            real,          -- precipitation
    Date            Date
    );

    Create Table cities (
    Name            Varchar(80),
    location        Point
    );

    __SQL


    SQL__

    Insert Into cities Values ('San Francisco', '(-194.0, 53.0)');

    Insert Into weather (Date, city, temp_hi, temp_lo) Values ('1994-11-29', 'Hayward', 54, 37);

    __SQL

    SQL__

    Select * From une Table Into Cursor test

    __SQL

    * de meme
    lcAlias = "test"
    SQL__

    Select * From Matable Into Cursor <<lcAlias>>

    __SQL


#Endif


* - * -------------------- Commentaire par Eddy Maue le 2013-07-31--------------------
* - *  mise  jour
* - *
* - *  Procedure :
* - *      Setup
* - *      DoSQLscript_assign
* - *      Connect
* - *      Dll
* - *      p_lPermnntConnection_assign
* - *
* - * -------------------- Fin - commantaires ----------------------------------------
* - *


Define Class  SQLClass As Custom

    p_lLocal = .F.             && local ou distant
    p_cServeurLocal=""         && destination local
    p_cServeurDistant = ""     && destination distante
    p_cPassword=""
    p_cDatabase=""             && database sur laquelle on veut travailler
    p_cConnectStr = ""
    p_nPort=5432               && port de communication avec le serveur de PostGreSQL
    p_nHandleConnect = 0       && handle de connection
    p_lPermnntConnection =.F.  && voir p_lPermnntConnection_assign  pour une connection permanente


    * Sortie du rsultat d'une requete Select * from .... where... ;;
    && pour sqlexec(hSql, cRequete, cAlias)
    p_cDefaultAlias = "SqlResult"

    Dimension p_aDB(1)
    Dimension p_aTable(1)

    DoSQLscript=""

    Procedure m_chaine

        With This

            .p_lLocal = .T.
            .p_cServeurLocal="localhost"
            .p_cServeurDistant = ""
            .p_cPassword="eddy1902"
            .p_cDatabase="Essais"


            .Setup()    && Initialisation de l'objet

        Endwith


    Endproc

    *  / Setup
    * / Eddy Maue a+  --   Crer le : 2007-09-02
    Procedure Setup()


        This.UnConnect() && if faut s'assurer qu'il n'y est pas une connexion d'tablie

        TEXT to this.p_cConnectStr  TEXTMERGE noshow

            DRIVER={PostgreSQL ODBC Driver(UNICODE)};
            DATABASE=<<this.p_cDatabase>>;
            SERVER=<< iif ( this.p_lLocal, this.p_cServeurLocal,this.p_cServeurDistant) >>;
            PORT=<<this.p_nPort>>;
            UID=postgres;
            PWD=<<this.p_cPassword>>;
            CA=d;
            A6=;
            A7=100;
            A8=4096;
            B0=255;
            B1=8190;
            BI=0;
            C2=dd_;
            CX=1c502bb;
            A1=7.4

        ENDTEXT




        Return .F.

    Endproc && Setup

    *  / m_GetDB
    * / Eddy Maue a+  --   Crer le : 2013-08-04
    Procedure m_GetDB

        Local lnRetVal, lcDB


        lcDB = Sys(2015)
        Try

            * extrait la liste des databases du serveur Postgres
            TEXT to this.DoSQLscript TEXTMERGE noshow

            Select datname From pg_database
            Where datistemplate = false
            into cursor <<lcDB>>

            ENDTEXT

            Select (lcDB)

            If Reccount()>0


                Copy To Array m.laDB Fields datname
                Acopy(m.laDB,This.p_aDB)

                lnRetVal = Reccount()

            Else

                lnRetVal = 0

            Endif

            Use && ferme le curseur lcDB

        Catch To oe

            ? Messagebox( oe.Message ,1)

        Finally

        Endtry

        Return m.lnRetVal

    Endproc && m_GetDB

    *  / m_GetTable
    * / Eddy Maue a+  --   Crer le : 2013-08-04
    Procedure m_GetTable
        Local lnRetVal, lcTable


        lcTable = Sys(2015)
        Try

            * extrait la liste des databases du serveur Postgres
            TEXT to this.DoSQLscript TEXTMERGE noshow

                 SELECT  tables.table_schema, tables.table_name, tables.table_type
                 FROM information_schema.tables
                 WHERE tables.table_type::text = 'BASE TABLE'::text
                 AND tables.table_schema::text = 'public'::text
                 ORDER BY tables.table_name,  tables.table_type;
                 into cursor <<lcTable>> ;

            ENDTEXT

            Select (lcTable)
            

            Local lnRcount
            m.lnRcount = Reccount()
            If m.lnRcount > 0

                * limine le caractre 0
             *   Replace All table_name With Chrtran(table_name, Chr(0),"")
                Locate

 
*!*                    For i = 1 To
*!*                        Copy To Array m.laTB Fields table_name All
*!*                        Acopy( m.laTB, This.p_aTable )

                Declare This.p_aTable(Reccount())
                With This
                
                    Scan All

                        This.p_aTable(Recno())=Chrtran(table_name, Chr(0),"")

                    EndScan
                    
                EndWith
                
                lnRetVal = Reccount()

                Else

                    lnRetVal = 0

                Endif

                Use && ferme le curseur lcTable

            Catch To oe

                ? Messagebox( oe.Message ,1)

            Finally

            Endtry

            Return m.lnRetVal


        Endproc && m_GetTable




        *  / DoSQLscript
        * / Eddy Maue a+  --   Crer le : 2007-09-02
        *  / DoSQLscript
        * / Eddy Maue a+  --   modifier le : 2013-08-03
    Procedure DoSQLscript_assign
        Lparameters pcScript

        * Local Array aCountInfo(1)
        If This.p_nHandleConnect < 1

            This.Connect()

        Endif

        Local lcAlias, lcSearchExp

        lcAlias = This.p_cDefaultAlias
        *set step on
        Try

            * ---------------------------------------------------------SQLExec()

            lcSearchExp = "into cursor"

            p1 = Atc( m.lcSearchExp , pcScript )

            If  p1 > 0

                p1 = Atc( m.lcSearchExp , pcScript )

                lcAlias = Substr( pcScript , p1+Len("insert into"))

                m.pcScript = Substr(m.pcScript,1 , p1 -1) + Iif(";"$lcAlias , ";","")
                m.lcAlias = Chrtran(m.lcAlias,";"+Chr(9)+Chr(10)+Chr(13)+Space(1),"")

            Endif



            lnValue = SQLExec(This.p_nHandleConnect,m.pcScript,lcAlias)


            If m.lnValue < 0

                Error Message()+Chr(13)+m.pcScript

            Endif

            * -------------------------Fin----------------------------SQLExec()


        Catch To oe

            ? Messagebox( oe.Message ,1)

        Finally

        Endtry

        If Not This.p_lPermnntConnection
            This.UnConnect()
        Endif

    Endproc && DoSQLscript



    Procedure UnConnect()
        Local lnValue , llTerniner , lnMsgRep

        #Define msgTITLE_BAR  "Erreur pour rompre une connexion"

        #Define msgERROR1     "il y a une erreur de niveau de la connexion : impossible de rompre la conexion"
        #Define msgERROR2     "il y a une erreur au niveau de l'environnement"

        #Define msgABORD    3
        #Define msgRETRY    4
        #Define msgIGNORE   5


        m.lnMsgRep = 0

        Do While Not m.llTerniner

            If This.p_nHandleConnect > 0

                lnValue = SQLDisconnect( This.p_nHandleConnect )



                Do Case
                    Case  m.lnValue = 1

                        && la connexion s'est interrompue avec succs
                        m.llTerniner = .T.

                    Case  m.lnValue = -1

                        m.lnMsgRep =   Messagebox( msgERROR1 , 2+64 , msgTITLE_BAR )

                    Case  m.lnValue = -2

                        m.lnMsgRep =   Messagebox( msgERROR2 , 5+64 , msgTITLE_BAR )


                Endcase

                Do Case
                    Case m.lnMsgRep = msgRETRY

                        Loop

                    Case m.lnMsgRep = msgIGNORE

                        Exit

                    Case m.lnMsgRep = msgABORD

                        Cancel

                    Otherwise

                        This.p_nHandleConnect = 0

                Endcase

            Else

                m.llTerniner = .T.

            Endif

        Enddo



    Endproc && UnConnect()



    Procedure Init && of SQLClass

        This.Dll()

    Endproc && SQLClass :: Init

    Procedure Destroy && of SQLClass

        This.UnConnect()

    Endproc && SQLClass :: Destroy

    Procedure Error(nError, cMethod, nLine) && of SQLClass

    Endproc && Error of SQLClass


    *  / p_lPermnntConnection_assign
    * / Eddy Maue a+  --   Crer le : 2013-07-31
    *   Ajout pour des besons que je n'avais pas  l'poque
    Procedure p_lPermnntConnection_assign
        Lparameters tlValue


        This.p_lPermnntConnection = tlValue

    Endproc && p_lPermnntConnection_assign




    *  / Connect && SQLClass
    * / Eddy Maue a+  --   Crer le : 2007-09-02
    Procedure Connect && SQLClass
        lnTentative = 5
        lnLapstime = 1 && secondes
        llOK = .F.

        For i = 1 To m.lnTentative

            This.p_nHandleConnect= Sqlstringconnect(This.p_cConnectStr,.T.)

            If This.p_nHandleConnect < 1

                Wait Window Nowait "Connexion en attente...."
                Sleep(m.lnLapstime*1000)

            Else

                llOK=.T.
                Exit

            Endif

        Endfor

        If Not llOK
            Messagebox("Connextion imposible avec le serveur "+ Iif(This.p_lLocal,"local", "distant"),48,"tablissement d'une connection...")
            Return .F.
        Endif

        Return .T.

    Endproc && Connect && SQLClass

    *  / DLL
    * / Eddy Maue a+  --   Crer le : 2013-07-21
    Procedure Dll

        Declare Sleep In WIN32API Long

    Endproc && DLL


Enddefine
